import { SerializableByFn, SerializableBySelf, toJSON } from '../../../modules';
export interface Serialize {
    toJSON(): toJSON<this>;
}
/** Constructor that return a serializable instance by `toJSON` method */
export type Serializable<T extends Constructor = Constructor> = T & Constructor<Serialize>;
/**
 * Typescript 5.0 decorator.
 */
export declare function Serialize<Class extends Constructor<SerializableBySelf<InstanceType<Class>> | SerializableByFn>>(Value: Class, _ctx?: ClassDecoratorContext<Class>): Serializable<Class>;
