"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indent = exports.Logger = void 0;
exports.Logger = {
    recording: false,
    records: [],
    record() {
        this.recording = true;
        return this;
    },
    printRecords() {
        this.records.forEach((record) => console.log(...[record].flat()));
        return this;
    },
    endRecord() {
        this.recording = false;
        return this;
    },
    timeEnd(label) {
        console.timeEnd(label);
        return this;
    },
    log(...v) {
        console.log(...v);
        if (this.recording) {
            this.records.push(v);
        }
        return this;
    },
};
const indent = (deep) => '  '.repeat(deep);
exports.indent = indent;
