#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
if (process.argv.includes('--help')) {
    console.log(`
usage: rtft [<args>] <?path>
args:
  --verbose             See all the info about tests.
  --include=<regex>     Regex to include files (ignore rt.config.ts).
  --exclude=<regex>     Regex to exclude files (ignore rt.config.ts).

  --help                Show this message.
`);
    process.exit(0);
}
const index_1 = require("./Tester/index");
const typescript_1 = __importDefault(require("typescript"));
const rt_options = {
    noEmit: true,
};
const configFile = typescript_1.default.readConfigFile('tsconfig.json', typescript_1.default.sys.readFile);
const parsedConfig = typescript_1.default.parseJsonConfigFileContent(configFile.config, typescript_1.default.sys, './');
const program = typescript_1.default.createProgram(parsedConfig.fileNames, { ...parsedConfig.options, ...rt_options });
process.exit(new index_1.ReadableTypesTester(program).runTests());
